<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class BillingComparisonFactory {

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
      $this->connection = $entityManager->getConnection();
      $this->entityManager = $entityManager;
    }

    public function getBillingComparison($parametros) {

      $sqlAlter = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";

      $std = $this->connection->prepare($sqlAlter);
      $std->execute();

      $sql = "SELECT DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, 'AGRUPAMENTO') AS NRCONTRATOFCT,
                  DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT ||' - '|| CONT.DSREFERENCIACONT, 'AGRUPAMENTO') AS NMCONTRATO,
                  CASE AGRUPCONT.IDPARCAGRUP
                      WHEN 'N' THEN
                          TO_CHAR(CONT.NRSEQCONTRATO)
                      ELSE
                         (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP(ORDER BY NRSEQCONTRATO)
                          FROM FCT_RELACAGRUPCONTFAT
                          WHERE NRFATURACONT = FAT.NRFATURACONT)
                  END AS NRSEQCONTRATO,
                  FAT.NRFATURACONT,
                  AGRUPCONT.NRMEDICAOFATURA,
                  FAT.NRPARCFATURA,
                  PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA,
                  PARCFAT.NRINSCRICAOPARC,
                  PARCFAT.NMSECUNDARIPARC AS NMFANTASIA,
                  FAT.IDTPFATURA,
                  FAT.IDSITUACAO AS IDSITUACAOFAT,
                  NULL AS IDSITUACAOMED,
                  FAT.DTINICOMPET,
                  FAT.DTFINCOMPET,
                  TO_CHAR(FAT.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(FAT.DTFINCOMPET, 'DD/MM/YYYY') AS PERIODO,
                  NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) AS VRTOTAL,

                  COMPARACAO.NRFATURACONT AS NRFATURACONT_COMP,
                  COMPARACAO.NRMEDICAOFATURA AS NRMEDICAOFATURA_COMP,
                  COMPARACAO.DTINICOMPET AS DTINICOMPET_COMP,
                  COMPARACAO.DTFINCOMPET AS DTFINCOMPET_COMP,
                  TO_CHAR(COMPARACAO.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(COMPARACAO.DTFINCOMPET, 'DD/MM/YYYY') AS PERIODO_COMP,
                  NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRVENCIMENTO) AS VRTOTAL_COMP,

                  NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRVENCIMENTO) AS VRDIFERENCA,
                  ROUND(ABS(NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRVENCIMENTO)) / DECODE(NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO), 0, 1, NVL(FAT.VRNEGCONTR, FAT.VRVENCIMENTO)) * 100, 2) AS VRPERCDIFERENCA,

                  FAT.NRORG,
                  FCT_TIPOORCAMENTO.NRTIPOORCAMENTO,
                  FCT_TIPOORCAMENTO.NMTIPOORCAMENTO,
                  FAT.NRESTRUTURAM,
                  EST.NMESTRUTURAM
          FROM FCT_FATURACONT FAT
          INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
          ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
          LEFT JOIN FCT_CONTRATO CONT
          ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
          INNER JOIN PARCNEGOCIO PARCFAT
          ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
          LEFT JOIN FCT_TIPOORCAMENTO
          ON CONT.NRTIPOORCAMENTO = FCT_TIPOORCAMENTO.NRTIPOORCAMENTO
          LEFT JOIN ESTRUTURAM EST
          ON FAT.NRESTRUTURAM = EST.NRESTRUTURAM

          INNER JOIN (
              SELECT FATC.NRFATURACONT,
                     FATC.DTINICOMPET,
                     FATC.DTFINCOMPET,
                     FATC.VRVENCIMENTO,
                     FATC.VRFATURADO,
                     FATC.VRFALTAFATURAR,
                     FATC.VRNEGCONTR,
                     FATC.NRPARCFATURA,
                     FATC.IDTPFATURA,
                     RELC.NRMEDICAOFATURA
                FROM FCT_FATURACONT FATC
                LEFT JOIN FCT_RELACAGRUPCONTFAT RELC
                  ON FATC.NRFATURACONT = RELC.NRFATURACONT
          ) COMPARACAO
          ON TRUNC(COMPARACAO.DTINICOMPET) BETWEEN TRUNC(ADD_MONTHS(FAT.DTINICOMPET, - :QTPARCELAS)) AND TRUNC(ADD_MONTHS(FAT.DTFINCOMPET, - :QTPARCELAS))
          AND TRUNC(COMPARACAO.DTFINCOMPET) BETWEEN TRUNC(ADD_MONTHS(FAT.DTINICOMPET, - :QTPARCELAS)) AND TRUNC(ADD_MONTHS(FAT.DTFINCOMPET, - :QTPARCELAS))
          AND COMPARACAO.NRPARCFATURA = FAT.NRPARCFATURA
          AND COMPARACAO.IDTPFATURA = FAT.IDTPFATURA

          WHERE (((INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(CONT.NRSEQCONTRATO) || '_') > 0)
                  OR (:NRSEQCONTRATO IS NULL)))
          AND (((INSTR(:NRPARCNEGOCIO, '_' || TO_CHAR(PARCFAT.NRPARCNEGOCIO) || '_') > 0)
                  OR (:NRPARCNEGOCIO IS NULL)))
          AND (((INSTR(:NRTIPOORCAMENTO, '_' || TO_CHAR(FCT_TIPOORCAMENTO.NRTIPOORCAMENTO) || '_') > 0)
                  OR (:NRTIPOORCAMENTO IS NULL)))
          AND (((INSTR(:IDTPFATURA, '_' || TO_CHAR(FAT.IDTPFATURA) || '_') > 0)
                  OR (:IDTPFATURA IS NULL)))
          AND FAT.DTINICOMPET = :DTINICOMPET
          AND FAT.DTFINCOMPET = :DTFINCOMPET

          UNION ALL

          SELECT CONT.NRCONTRATOFCT,
                  CONT.NRCONTRATOFCT ||' - '|| CONT.DSREFERENCIACONT AS NMCONTRATO,
                  TO_CHAR(CONT.NRSEQCONTRATO) AS NRSEQCONTRATO,
                  NULL AS NRFATURACONT,
                  MED.NRMEDICAOFATURA,
                  MED.NRPARCFATURA,
                  PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA,
                  PARCFAT.NRINSCRICAOPARC,
                  PARCFAT.NMSECUNDARIPARC AS NMFANTASIA,
                  'X' AS IDTPFATURA,
                  NULL AS IDSITUACAOFAT,
                  MED.IDSITUACAO AS IDSITUACAOMED,
                  MED.DTINICOMPET,
                  MED.DTFINCOMPET,
                  TO_CHAR(MED.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(MED.DTFINCOMPET, 'DD/MM/YYYY') AS PERIODO,
                  NVL(MED.VRNEGCONTR, MED.VRMEDICAO) AS VRTOTAL,

                  NULL AS NRFATURACONT_COMP,
                  COMPARACAO.NRMEDICAOFATURA AS NRMEDICAOFATURA_COMP,
                  COMPARACAO.DTINICOMPET AS DTINICOMPET_COMP,
                  COMPARACAO.DTFINCOMPET AS DTFINCOMPET_COMP,
                  TO_CHAR(COMPARACAO.DTINICOMPET, 'DD/MM/YYYY') || ' - ' || TO_CHAR(COMPARACAO.DTFINCOMPET, 'DD/MM/YYYY') AS PERIODO_COMP,
                  NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRMEDICAO) AS VRTOTAL_COMP,

                  NVL(MED.VRNEGCONTR, MED.VRMEDICAO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRMEDICAO) AS VRDIFERENCA,
                  ROUND(ABS(NVL(MED.VRNEGCONTR, MED.VRMEDICAO) - NVL(COMPARACAO.VRNEGCONTR, COMPARACAO.VRMEDICAO)) / DECODE(NVL(MED.VRNEGCONTR, MED.VRMEDICAO), 0, 1, NVL(MED.VRNEGCONTR, MED.VRMEDICAO)) * 100, 2) AS VRPERCDIFERENCA,

                  MED.NRORG,
                  FCT_TIPOORCAMENTO.NRTIPOORCAMENTO,
                  FCT_TIPOORCAMENTO.NMTIPOORCAMENTO,
                  MED.NRESTRUTURAM,
                  EST.NMESTRUTURAM
          FROM FCT_MEDICAOFATURA MED
          LEFT JOIN FCT_CONTRATO CONT
          ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
          INNER JOIN PARCNEGOCIO PARCFAT
          ON MED.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
          LEFT JOIN FCT_TIPOORCAMENTO
          ON CONT.NRTIPOORCAMENTO = FCT_TIPOORCAMENTO.NRTIPOORCAMENTO
          LEFT JOIN ESTRUTURAM EST
          ON MED.NRESTRUTURAM = EST.NRESTRUTURAM

          INNER JOIN FCT_MEDICAOFATURA COMPARACAO
          ON TRUNC(COMPARACAO.DTINICOMPET) BETWEEN TRUNC(ADD_MONTHS(MED.DTINICOMPET, - :QTPARCELAS)) AND TRUNC(ADD_MONTHS(MED.DTFINCOMPET, - :QTPARCELAS))
          AND TRUNC(COMPARACAO.DTFINCOMPET) BETWEEN TRUNC(ADD_MONTHS(MED.DTINICOMPET, - :QTPARCELAS)) AND TRUNC(ADD_MONTHS(MED.DTFINCOMPET, - :QTPARCELAS))
          AND MED.NRPARCFATURA = COMPARACAO.NRPARCFATURA
          AND MED.NRSEQCONTRATO = COMPARACAO.NRSEQCONTRATO
          AND COMPARACAO.IDSITUACAO IN ('3', '4')
          AND (SELECT LISTAGG(CDSERVORCA, ',') WITHIN GROUP(ORDER BY CDSERVORCA) FROM FCT_ITMEDICAOFATURA
                   WHERE NRMEDICAOFATURA = MED.NRMEDICAOFATURA)
               =
               (SELECT LISTAGG(CDSERVORCA, ',') WITHIN GROUP(ORDER BY CDSERVORCA) FROM FCT_ITMEDICAOFATURA
                   WHERE NRMEDICAOFATURA = COMPARACAO.NRMEDICAOFATURA)

          WHERE (((INSTR(:NRSEQCONTRATO, '_' || TO_CHAR(MED.NRSEQCONTRATO) || '_') > 0)
                  OR (:NRSEQCONTRATO IS NULL)))
          AND (((INSTR(:NRPARCNEGOCIO, '_' || TO_CHAR(PARCFAT.NRPARCNEGOCIO) || '_') > 0)
                  OR (:NRPARCNEGOCIO IS NULL)))
          AND (((INSTR(:NRTIPOORCAMENTO, '_' || TO_CHAR(FCT_TIPOORCAMENTO.NRTIPOORCAMENTO) || '_') > 0)
                  OR (:NRTIPOORCAMENTO IS NULL)))
          AND MED.DTINICOMPET = :DTINICOMPET
          AND MED.DTFINCOMPET = :DTFINCOMPET
          AND MED.IDSITUACAO IN ('3', '4')
          AND NOT (MED.IDSITUACAO = '4' AND COMPARACAO.IDSITUACAO = '4')";

      $std = $this->connection->prepare($sql);
      $std->execute($parametros);
      return $std->fetchAll();
    }

    public function getContractsBillingComparison() {

      $sql = "SELECT FCT_CONTRATO.NRSEQCONTRATO, FCT_CONTRATO.NRCONTRATOFCT ||' - '|| PARCNEGOCIO.NMSECUNDARIPARC AS NRCONTRATOFCT
                 FROM FCT_CONTRATO
                 JOIN PARCNEGOCIO
                   ON PARCNEGOCIO.NRPARCNEGOCIO = FCT_CONTRATO.NRPARCNEGOCIO
                WHERE FCT_CONTRATO.IDSITUACAOCONTRATO = 'A'
                  AND FCT_CONTRATO.IDATIVO = 'S'";

      return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getBusinessPartnersBilling() {

      $sql = "SELECT NRPARCNEGOCIO, NMSECUNDARIPARC
                  FROM PARCNEGOCIO
                 WHERE CDTIPOPARCPRINCIPAL = 'CLIENTE'
                   AND IDATIVO = 'S'
                   ORDER BY NMSECUNDARIPARC";

      return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getBillingScopes() {

      $sql = "SELECT NRTIPOORCAMENTO, NMTIPOORCAMENTO
                FROM FCT_TIPOORCAMENTO
                WHERE IDATIVO = 'S'
                ORDER BY NMTIPOORCAMENTO";

      return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function billingComparisonOfTheParcelTab($parametros) {

      $sql = "SELECT ITFAT.NRITFATURACONT,
                   ITFAT.NRFATURACONT,
                   ITFAT.NRSEQCONTRATO,
                   ITFAT.NRITEMOCONTRATO,
                   ITCONT.NMITEMCONTRATO,
                   ITFAT.IDSITUACAO,
                   ITFAT.VRVENCIMENTO,
                   ITFAT.VRFATURADO,
                   ITFAT.VRFALTAFATURAR,
                   ITFAT.DSJUSTIFICATIVA,
                   ITFAT.IDATIVO,
                   ITFAT.NRORG,
                   ITFAT.VRNEGCONTR
              FROM FCT_ITFATURACONT ITFAT
             INNER JOIN FCT_ITEMCONTRATO ITCONT
                ON ITFAT.NRSEQCONTRATO   = ITCONT.NRSEQCONTRATO
               AND ITFAT.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
               AND ITFAT.NRORG           = ITCONT.NRORG
             WHERE ITFAT.NRFATURACONT = :NRFATURACONT
             ORDER BY ITCONT.NRSEQCONTRATO";

      return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function billingComparisonOfMeasurementItems($parametros) {

      $sql = "SELECT
                NRITMEDICAOFATURA,
                NRMEDICAOFATURA,
                NRSEQCONTRATO,
                NRITEMOCONTRATO,
                NMITEMCONTRATO,
                CDSERVORCA,
                CDPRODFATURA,
                IDSITUACAO,
                VRTOTITEMCONT,
                DECODE(VRTOTITEMCONT, 0, 0,(VRDESCITEM * 100) / VRTOTITEMCONT) AS VRPERCDESCITEM,
                VRDESCITEM,
                VRITEMCONT AS VRTOTITEMCOMDESC,
                IDATIVO,
                NRORG,
                DTINCLUSAO,
                NRORGINCLUSAO,
                CDOPERINCLUSAO,
                DTULTATU,
                NRORGULTATU,
                CDOPERULTATU,
                VRNEGCONTR,
                NRPARCELASNEGCONTR
            FROM
                (SELECT
                        ITMED.NRITMEDICAOFATURA,
                        ITMED.NRMEDICAOFATURA,
                        ITMED.NRSEQCONTRATO,
                        ITMED.NRITEMOCONTRATO,
                        ITCONT.NMITEMCONTRATO,
                        ITMED.CDSERVORCA,
                        ITMED.CDPRODFATURA,
                        ITMED.IDSITUACAO,
                        ITMED.VRTOTITEMCONT,
                        ITMED.VRITEMCONT,
                        NVL(ITMED.VRTOTITEMCONT, 0) - NVL(ITMED.VRITEMCONT, 0) AS VRDESCITEM,
                        ITMED.IDATIVO,
                        ITMED.NRORG,
                        ITMED.DTINCLUSAO,
                        ITMED.NRORGINCLUSAO,
                        ITMED.CDOPERINCLUSAO,
                        ITMED.DTULTATU,
                        ITMED.NRORGULTATU,
                        ITMED.CDOPERULTATU,
                        ITMED.VRNEGCONTR,
                        ITMED.NRPARCELASNEGCONTR
                   FROM FCT_ITMEDICAOFATURA ITMED
                  INNER JOIN FCT_ITEMCONTRATO ITCONT
                     ON ITMED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                    AND ITMED.NRITEMOCONTRATO = ITCONT.NRITEMOCONTRATO
                    AND ITMED.NRORG = ITCONT.NRORG
                   LEFT JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                     ON ITMED.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                    AND ITMED.NRORG = ITNEG.NRORG
                   LEFT JOIN FCT_NEGOCIACAOCONTRATO NEG
                     ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                    AND ITNEG.NRORG = NEG.NRORG
                  WHERE NRMEDICAOFATURA = :NRMEDICAOFATURA )";

      return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }

    public function billingComparisonOfVariableMeasures($parametros) {

      $sql = "SELECT
                NRMEDICAOFATURA,
                IDELEMENTORAIZ,
                NMELEMENTORAIZ,
                CDTPMEDIDAVARIAVEL,
                DSTPMEDIDAVARIAVEL,
                QTMEDIDAVARIAVEL,
                IDMULTIPVARIACAO,
                IDCALCULADO,
                IDATIVO,
                NRORG,
                QTFRANQUIA,
                QTMEDIDAMEDICAO,
                VRITEMCONT,
                QTMEDIDAVENDIDA,
                NRSEQCONTRATO,
                VRUNITARIO,
                VRPRECOVARIACAO,
                QTMEDIDACONTR,
                VRTOTAL,
                CASE
                    WHEN VRITEMCONTCOMDESC IS NOT NULL THEN
                        VRITEMCONTCOMDESC
                    WHEN NVL(VRDESCITEM, 0) > 0 THEN
                        DECODE(IDTPDESCONTO, 'V', VRTOTAL - VRDESCITEM, VRTOTAL - ROUND((VRTOTAL * VRPERCDESCITEM / 100), 2))
                    ELSE
                        VRTOTAL
                END AS VRTOTALCOMDESC,
                CDSERVORCA,
                NRMEDVARMEDICAOFATURA,
                IDTPDESCONTO,
                VRDESCITEM,
                VRPERCDESCITEM,
                VRITEMCONTCOMDESC,
                VRNEGCONTR,
                NRPARCELASNEGCONTR
            FROM
                (
                    SELECT
                        NRMEDICAOFATURA,
                        IDELEMENTORAIZ,
                        NMELEMENTORAIZ,
                        CDTPMEDIDAVARIAVEL,
                        DSTPMEDIDAVARIAVEL,
                        QTMEDIDAVARIAVEL,
                        IDMULTIPVARIACAO,
                        IDCALCULADO,
                        IDATIVO,
                        NRORG,
                        QTFRANQUIA,
                        QTMEDIDAMEDICAO,
                        VRITEMCONT,
                        QTMEDIDAVENDIDA,
                        NRSEQCONTRATO,
                        DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO, DECODE(IDELEMENTORAIZ, NULL, VRUNITARIO, DECODE(IDPREVCOBRFUT, 'S', VRUNITARIO
                        , VRUNITARIO * QTMEDIDACONTR))) AS VRUNITARIO,
                        VRPRECOVARIACAO,
                        QTMEDIDACONTR,
                        DECODE(IDMULTIPVARIACAO, 'S', VRUNITARIO * QTMEDIDAMEDICAO, DECODE(IDELEMENTORAIZ, NULL, VRUNITARIO * QTMEDIDAMEDICAO
                        , DECODE(IDPREVCOBRFUT, 'S', VRUNITARIO * QTMEDIDAMEDICAO, VRUNITARIO * QTMEDIDACONTR))) AS VRTOTAL,
                        CDSERVORCA,
                        NRMEDVARMEDICAOFATURA,
                        IDTPDESCONTO,
                        VRDESCITEM,
                        VRPERCDESCITEM,
                        VRITEMCONTCOMDESC,
                        VRNEGCONTR,
                        NRPARCELASNEGCONTR
                    FROM
                        (
                            SELECT DISTINCT
                                MEDVAR.NRMEDVARMEDICAOFATURA,
                                MEDVAR.CDSERVORCA,
                                MEDVAR.NRMEDICAOFATURA,
                                MEDVAR.IDELEMENTORAIZ,
                                ELE.NMSERVORCA            AS NMELEMENTORAIZ,
                                MEDVAR.CDTPMEDIDAVARIAVEL,
                                MEDIDA.DSTPMEDIDASERV     AS DSTPMEDIDAVARIAVEL,
                                MEDVAR.QTMEDIDAVARIAVEL,
                                MEDVAR.IDMULTIPVARIACAO,
                                MEDVAR.IDCALCULADO,
                                MEDVAR.IDATIVO,
                                MEDVAR.NRORG,
                                MEDVAR.QTFRANQUIA,
                                MEDVAR.QTMEDIDAMEDICAO,
                                MEDVAR.VRITEMCONT,
                                MEDVAR.QTMEDIDAVENDIDA,
                                MED.NRSEQCONTRATO,
                                VAR.VRPRECOVARIACAO       AS VRPRECOVARIACAO,
                                VARVEND.VRPRECOVARIACAO   AS VRPRECOVARIACAOVEND,
                                ITCONT.VRUNITITEMCONT,
                                DECODE(MEDVAR.IDELEMENTORAIZ, NULL, MEDVAR.QTMEDIDAVENDIDA, ITCONT.QTMEDIDACONTR) AS QTMEDIDACONTR,
                                DECODE(MEDVAR.IDELEMENTORAIZ, NULL, NVL(VAR.VRPRECOVARIACAO, ITCONT.VRUNITITEMCONT), DECODE(NVL(VAR.VRPRECOVARIACAO
                                , 0), 0, ITCONT.VRUNITITEMCONT, DECODE(NVL(VARVEND.VRPRECOVARIACAO, 0), 0, VAR.VRPRECOVARIACAO, ITCONT.VRUNITITEMCONT
                                / VARVEND.VRPRECOVARIACAO * VAR.VRPRECOVARIACAO))) AS VRUNITARIO,
                                ITNEG.IDTPDESCONTO,
                                ITNEG.VRDESCITEM,
                                ITNEG.VRPERCDESCITEM,
                                MEDVAR.VRITEMCONTCOMDESC,
                                MEDVAR.VRNEGCONTR,
                                MEDVAR.NRPARCELASNEGCONTR,
                                NEG.IDPREVCOBRFUT
                            FROM FCT_MEDVARMEDICAOFATURA    MEDVAR
                            JOIN FCT_MEDICAOFATURA MED
                              ON MEDVAR.NRMEDICAOFATURA = MED.NRMEDICAOFATURA
                            JOIN FCT_ITEMCONTRATO ITCONT
                              ON MED.NRSEQCONTRATO = ITCONT.NRSEQCONTRATO
                             AND MEDVAR.CDSERVORCA = ITCONT.CDSERVORCA
                             AND MEDVAR.CDTPMEDIDAVARIAVEL = ITCONT.CDTPMEDIDAVARIAVEL
                             AND ( MEDVAR.IDELEMENTORAIZ = ITCONT.IDELEMENTO
                                    OR MEDVAR.IDELEMENTORAIZ IS NULL
                                    AND ITCONT.NRITEMCONTRATOPAI IS NULL )
                            JOIN FCT_ITNEGOCIACAOCONTRATO ITNEG
                              ON ITCONT.NRITEMOCONTRATO = ITNEG.NRITEMOCONTRATO
                            JOIN FCT_NEGOCIACAOCONTRATO NEG
                              ON ITNEG.NRNEGOCIACAOCONTRATO = NEG.NRNEGOCIACAOCONTRATO
                           INNER JOIN FCT_VARPRECBASESERVCONT    VAR
                              ON MED.NRSEQCONTRATO = VAR.NRSEQCONTRATO
                             AND ITCONT.CDTPMEDIDAVARIAVEL = VAR.CDTPMEDIDAVARIAVEL
                             AND MEDVAR.CDSERVORCA = VAR.CDSERVORCA
                             AND ( ( MEDVAR.IDELEMENTORAIZ IS NOT NULL
                                        AND ITCONT.CDTPMEDIDASERV = VAR.CDTPMEDIDASERV )
                                        OR MEDVAR.IDELEMENTORAIZ IS NULL )
                             AND DECODE(MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA, 0, 1, MEDVAR.QTMEDIDAMEDICAO + MEDVAR.QTFRANQUIA) BETWEEN VAR.QTMEDIDAINIVARIACAO
                             AND VAR.QTMEDIDAFIMVARIACAO
                            LEFT JOIN FCT_VARPRECBASESERVCONT VARVEND
                              ON MED.NRSEQCONTRATO = VARVEND.NRSEQCONTRATO
                             AND ITCONT.CDTPMEDIDAVARIAVEL = VARVEND.CDTPMEDIDAVARIAVEL
                             AND MED.NRORG = VARVEND.NRORG
                             AND MEDVAR.CDSERVORCA = VARVEND.CDSERVORCA
                             AND ( ( MEDVAR.IDELEMENTORAIZ IS NOT NULL
                                        AND ITCONT.CDTPMEDIDASERV = VARVEND.CDTPMEDIDASERV )
                                        OR MEDVAR.IDELEMENTORAIZ IS NULL )
                             AND DECODE(NVL(MEDVAR.QTMEDIDAVENDIDA, 0), 0, 1, MEDVAR.QTMEDIDAVENDIDA) BETWEEN VARVEND.QTMEDIDAINIVARIACAO
                             AND VARVEND.QTMEDIDAFIMVARIACAO
                            LEFT JOIN FCT_SERVICOORCA            ELE
                              ON ( MEDVAR.IDELEMENTORAIZ = ELE.IDELEMENTO
                                        OR MEDVAR.IDELEMENTORAIZ IS NULL
                                        AND MEDVAR.CDSERVORCA = ELE.CDSERVORCA )
                             AND MEDVAR.NRORG = ELE.NRORG
                            LEFT JOIN FCT_TIPOMEDIDASERV MEDIDA
                              ON MEDVAR.CDTPMEDIDAVARIAVEL = MEDIDA.CDTPMEDIDASERV
                             AND MEDVAR.NRORG = MEDIDA.NRORG
                           WHERE MED.NRMEDICAOFATURA = :NRMEDICAOFATURA ))";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $parametros);
    }
}