<?php
namespace SM\Service;

use SM\Factory\BillingComparisonFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;

class BillingComparisonService {

    protected $BillingComparisonFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (BillingComparisonFactory $BillingComparisonFactory, Environment $Environment, NewCode $newCode) {
        $this->BillingComparisonFactory  = $BillingComparisonFactory;
        $this->Environment               = $Environment;
        $this->newCode                   = $newCode;
    }

    public function getBillingComparison($parametros) {

      // debugApi([$parametros]);

       // formatando os parametros do contrato para _019_1092_1982
        if ($parametros['NRSEQCONTRATO'] != null) {
          $nrsAux = implode('_', $parametros['NRSEQCONTRATO']);
          $nrs = '_'.$nrsAux.'_';
        } else {
          $nrs = $parametros['NRSEQCONTRATO'];
        }

        if ($parametros['NRPARCNEGOCIO'] != null) {
          $nrsParcAux = implode('_', $parametros['NRPARCNEGOCIO']);
          $nrsParc = '_'.$nrsParcAux.'_';
        } else {
          $nrsParc = $parametros['NRPARCNEGOCIO'];
        }

        if ($parametros['NRTIPOORCAMENTO'] != null) {
          $nrsTPAux = implode('_', $parametros['NRTIPOORCAMENTO']);
          $nrsTO = '_'.$nrsTPAux.'_';
        } else {
          $nrsTO = $parametros['NRTIPOORCAMENTO'];
        }

        if ($parametros['IDTPFATURA'] != null) {
          $nrsIDAux = implode('_', $parametros['IDTPFATURA']);
          $nrsID = '_'.$nrsIDAux.'_';
        } else {
          $nrsID = $parametros['IDTPFATURA'];
        }

        $params = array(
            "DTINICOMPET"     =>  $parametros['DTINICOMPET'],
            "DTFINCOMPET"     =>  $parametros['DTFINCOMPET'],
            "QTPARCELAS"      =>  $parametros['QTPARCELAS'],
            "NRSEQCONTRATO"   =>  $nrs,
            "NRPARCNEGOCIO"   =>  $nrsParc,
            "NRTIPOORCAMENTO" => $nrsTO,
            "IDTPFATURA"      => $nrsID
        );
        return $this->BillingComparisonFactory->getBillingComparison($params);
    }

    public function getContractsBillingComparison() {
        return $this->BillingComparisonFactory->getContractsBillingComparison();
    }

    public function getBusinessPartnersBilling() {
        return $this->BillingComparisonFactory->getBusinessPartnersBilling();
    }

    public function getBillingScopes() {
       return $this->BillingComparisonFactory->getBillingScopes();
    }

    public function billingComparisonOfTheParcelTab($parametros) {

       $param = array (
         "NRFATURACONT" => $parametros['NR']
        );

       return $this->BillingComparisonFactory->billingComparisonOfTheParcelTab($param);
    }

    public function billingComparisonOfMeasurementItems($parametros) {
      
      $param = array (
         "NRMEDICAOFATURA" => $parametros['NR']
        );
      
       return $this->BillingComparisonFactory->billingComparisonOfMeasurementItems($param);
    }

    public function billingComparisonOfVariableMeasures($parametros) {
      
      $param = array (
         "NRMEDICAOFATURA" => $parametros['NR']
        );
        
       return $this->BillingComparisonFactory->billingComparisonOfVariableMeasures($param);
    }

}